package com.astro.bibliotheca.api.worldenough;

import com.astro.bibliotheca.worldenough.impl.entry.BlobEntry;
import net.minecraft.block.state.IBlockState;
import net.minecraft.world.biome.Biome;

public interface SpawnEntry {
    IBlockState getState();

    int getSize();

    int getWeight();

    int getFrequency();

    int getMinHeight();

    int getMaxHeight();

    Biome[] getBiomes();

    default void parseJson() {

    }

    static SpawnEntry createBlobEntry(IBlockState state, int size, int weight, int frequency, int minHeight, int maxHeight, Biome... biomes) {
        return new BlobEntry(  state, size, weight, frequency, minHeight, maxHeight, biomes);
    }

    String getTypeString();
}
