package com.astro.bibliotheca.pulsar.content;

import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.client.renderer.color.IItemColor;
import net.minecraft.item.EnumDyeColor;
import net.minecraft.item.ItemDye;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.client.model.ModelLoader;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import javax.annotation.Nonnull;

public class ItemColour extends ItemEnum<EnumDyeColor> implements IColorProviderItem {

    private int layer;

    public ItemColour(String name, int layer) {
        super(name, EnumDyeColor.values());
        this.layer = layer;
    }

    @Override
    public IItemColor getColor() {
        return (itemStack, i) -> {
            if (i == layer)
                return ItemDye.field_150922_c[EnumDyeColor.func_176764_b(itemStack.func_77960_j()).func_176767_b()];
            return 0xFFFFF;
        };
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void initModels(@Nonnull ModelRegistryEvent event) {
        for (EnumDyeColor color : EnumDyeColor.values()) {
            ModelLoader.setCustomModelResourceLocation(this, color.func_176765_a(), new ModelResourceLocation(getRegistryName(), "inventory"));
        }
    }
}
