package com.astro.bibliotheca.pulsar.content;

import mcp.MethodsReturnNonnullByDefault;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.EnumRarity;
import net.minecraft.item.ItemStack;
import net.minecraft.util.IStringSerializable;
import net.minecraft.util.NonNullList;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.client.model.ModelLoader;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import javax.annotation.ParametersAreNonnullByDefault;

@ParametersAreNonnullByDefault
@MethodsReturnNonnullByDefault
public class ItemEnum<E extends Enum<E> & IStringSerializable> extends ItemBase {
    private final E[] values;

    public ItemEnum(String name, E[] values) {
        super(name);
        this.values = values;
        func_77627_a(values.length > 1);
    }

    @Override
    public void func_150895_a(CreativeTabs tab, NonNullList<ItemStack> items) {
        if (func_194125_a(tab))
            for (E e : values)
                items.add(new ItemStack(this, 1, e.ordinal()));
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void initModels(ModelRegistryEvent event) {
        for (E e : values)
            ModelLoader.setCustomModelResourceLocation(this, e.ordinal(), new ModelResourceLocation(getRegistryName(), "type=" + e.func_176610_l()));
    }

    @Override
    public EnumRarity func_77613_e(ItemStack stack) {
        E e = values[stack.func_77960_j()];
        if (e instanceof IRarityHandler)
            return ((IRarityHandler) e).getRarity();
        return super.func_77613_e(stack);
    }

    @Override
    public String func_77667_c(ItemStack stack) {
        return super.func_77667_c(stack) + "." + values[stack.func_77960_j()].func_176610_l();
    }
}
