package com.astro.bibliotheca.pulsar.gui;

import com.astro.bibliotheca.pulsar.control.PulseManager;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.fml.common.network.IGuiHandler;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import javax.annotation.Nullable;

public class PulsarGuiHandler implements IGuiHandler {
    private final PulseManager manager;

    public PulsarGuiHandler(PulseManager manager) {
        this.manager = manager;
    }

    @Nullable
    @Override
    public Object getServerGuiElement(int ID, EntityPlayer player, World world, int x, int y, int z) {
        GuiEvent event = new GuiEvent(Side.SERVER, ID, new BlockPos(x, y, z), world, player);
        manager.propagateEvent(event);
        return event.getGui();
    }

    @Nullable
    @Override
    @SideOnly(Side.CLIENT)
    public Object getClientGuiElement(int ID, EntityPlayer player, World world, int x, int y, int z) {
        GuiEvent event = new GuiEvent(Side.CLIENT, ID, new BlockPos(x, y, z), world, player);
        manager.propagateEvent(event);
        return event.getGui();
    }
}
