package com.astro.bibliotheca.worldenough.impl;

import com.astro.bibliotheca.api.worldenough.DimensionLogic;
import com.astro.bibliotheca.api.worldenough.SpawnLogic;
import com.google.common.collect.ImmutableMap;
import com.google.common.collect.Maps;

import java.util.Map;

public class ImplSpawnLogic implements SpawnLogic {
    private final Map<Integer, DimensionLogic> dimensionLogic = Maps.newTreeMap();

    @Override
    public DimensionLogic getDimension(int dim) {
        if (!dimensionLogic.containsKey(dim))
            dimensionLogic.put(dim, new ImplDimensionLogic(this));
        return dimensionLogic.get(dim);
    }

    @Override
    public Map<Integer, DimensionLogic> getAllDimensions() {
        return ImmutableMap.copyOf(dimensionLogic);
    }

}
