package com.astro.bibliotheca.worldenough.impl;

import com.astro.bibliotheca.api.worldenough.SpawnLogic;
import com.astro.bibliotheca.api.worldenough.WorldEnoughAPI;
import com.google.common.collect.ImmutableMap;
import com.google.common.collect.Maps;

import java.util.Map;

public class ImplWEApi implements WorldEnoughAPI {

    private final Map<String, SpawnLogic> spawnLogic = Maps.newTreeMap();

    @Override
    public SpawnLogic createSpawnLogic() {
        return new ImplSpawnLogic();
    }

    @Override
    public SpawnLogic getSpawnLogic(String id) {
        return spawnLogic.get(id);
    }

    public void registerSpawnLogic(String id, SpawnLogic spawnLogic) {
        this.spawnLogic.put(id, spawnLogic);
    }

    @Override
    public Map<String, SpawnLogic> getAllSpawnLogic() {
        return ImmutableMap.copyOf(spawnLogic);
    }
}
