package com.astro.bibliotheca.worldenough.impl.entry;

import com.astro.bibliotheca.api.worldenough.SpawnEntry;
import net.minecraft.block.state.IBlockState;
import net.minecraft.world.biome.Biome;

public class BlobEntry implements SpawnEntry {
    private final IBlockState state;
    private final int size;
    private final int weight;
    private final int frequency;
    private final int minHeight;
    private final int maxHeight;
    private final Biome[] biomes;

    public BlobEntry(IBlockState state, int size, int weight, int frequency, int minHeight, int maxHeight, Biome... biomes) {
        this.state = state;
        this.size = size;
        this.weight = weight;
        this.frequency = frequency;
        this.minHeight = minHeight;
        this.maxHeight = maxHeight;
        this.biomes = biomes;
    }

    @Override
    public IBlockState getState() {
        return state;
    }

    @Override
    public int getSize() {
        return size;
    }

    @Override
    public int getWeight() {
        return weight;
    }

    @Override
    public int getFrequency() {
        return frequency;
    }

    @Override
    public int getMinHeight() {
        return minHeight;
    }

    @Override
    public int getMaxHeight() {
        return maxHeight;
    }

    @Override
    public Biome[] getBiomes() {
        return biomes;
    }

    @Override
    public String getTypeString() {
        return "bibliotheca:blob";
    }
}
